VAR
  long     tempch2
  long     stack[50]
CON
    _clkmode = xtal1 + pll16x                           
    _xinfreq = 5_000_000
    LEDs_START      = 16                      
    LEDs_END        = 18
    ' I/O and Baud rate for XBee comms 
    XB_Rx     = 1  
    XB_Tx     = 2
    XB_Baud   = 9600

    ' XBee addresses
    DL_Addr = 0    ' Send data to this address (base)
    MY_Addr = $5F77    ' This units address

    dpin = 15       'both din and dout of the mcp3208 are connected to this pin on the prop demo board.
    cpin = 14       'the clock pin of the mcp3208 is connected to this pin on the prop demo board.
    spin = 0        'the chip select pin of the mcp 3208 is connected to this pin on the prop demo board.
    mcp3208ratio = 0.0008056640625

OBJ
adc     : "MCP3208"
pst     : "Parallax Serial Terminal Plus"
fstr    : "FloatString"
f32     : "FloatMath"
sd      : "PropBOE MicroSD2"
XB      : "XBee_Object_2"
PUB Main
pst.start(9600)   'Start the Parallax Serial Terminal object at 115200 baud
adc.start(dpin, cpin, spin, 255)  'Start the MCP3208 object and enable all 8 channels as single-ended inputs.
XB.Start(XB_RX, XB_TX ,0, XB_Baud)

XB.AT_Init
XB.AT_ConfigVal(string("ATMY"), MY_Addr)   
XB.AT_ConfigVal(string("ATDL"), DL_Addr)
XB.AT_Config(string("ATAP 1"))' Switch to API mode            

sd.Mount(0)
sd.FileNew(String("Sensordata.txt"))
sd.FileOpen(String("Sensordata.txt"), "A")
sd.WriteStr(String("CH2 Values", 13, 10))
sd.UnMount
          
cognew (CH2, @stack)
sdwriter ' writes to SD Card

repeat                     ' Accept incoming in loop
  GetData

Pub GetData | IO, dataIn, value 
  dataIn := XB.rx          ' wait for incoming byte
  If dataIn == "i"         ' i = I/O control
     IO := XB.rx           ' Accept IO number as byte value
     value := XB.rx        ' Accept state (1/0) as byte
     dira[IO]~~            ' Set direction of pin
     outa[IO] := value     ' Set state of pin
       

PUB CH2   
dira[18]~~
outa[18]~
XB.Delay(1000)

repeat  
  
  pst.Str(String(pst#cs, pst#NL, pst#HM, "Temperature value= "))
  tempch2 := f32.FFloat(adc.in(2))
  tempch2 := f32.FMul((f32.FSub((f32.FMul(tempch2,  mcp3208ratio)), 0.50)), 100.0)
  pst.Str(fstr.FloatToString(tempch2))
  if (tempch2 => 20.0) AND (tempch2 < 30.0)     
      !outa[18]
      waitcnt(clkfreq + cnt)
  elseif (tempch2 => 18.0) AND (tempch2 < 20.0)
      !outa[18]
      waitcnt(clkfreq/2 + cnt)
  elseif (tempch2 => 16.0) AND (tempch2 < 18.0)
      !outa[18]
      waitcnt(clkfreq/4 + cnt)
  elseif (tempch2 => 14.0) AND (tempch2 < 16.0)
      !outa[18]
      waitcnt(clkfreq/8 + cnt)
  else  
      !outa[18]
      waitcnt(clkfreq/16 + cnt)
  tempch2 := fstr.FloatToString(tempch2)
  XB.str(tempch2)         ' send tempch2
  XB.Delay(5000)          ' wait 5 seconds and send again
  
PUB sdwriter
  repeat
    sd.Mount(0)
    sd.FileOpen(String("Sensordata.txt"), "A")
  
    sd.WriteDec(tempch2)
    sd.WriteByte(13)                             ' Carriage return
    sd.WriteByte(10)                             ' New line
    waitcnt(clkfreq * 5 + cnt)
    
    sd.FileClose  
   sd.Unmount  
       